/* codegen.c
 * R8C Code Generator
 * Input: Stack-machine Opcodes
 * Output: Opcodes for Register-as-Stack with Register renaming
 */

#include <stdio.h>

#define REGS 4

int se = 0; // Stack elements
int reg[REGS] = {0, 1, 2, 3};  // Register usage

prregs() {
  // printf ("\t\tregs = %d %d %d %d\n", reg[0], reg[1], reg[2], reg[3]);
}

void pushrename() {
  int tmp;
  if (se >= REGS) {
    printf("PUSH.W  R%d\n", reg[3]);
  }
  tmp = reg[3];
  reg[3] = reg[2];
  reg[2] = reg[1];
  reg[1] = reg[0];
  reg[0] = tmp;
  ++se;
}

void poprename() {
  int tmp;
  --se;
  tmp = reg[0]; 
  reg[0] = reg[1];
  reg[1] = reg[2];
  reg[2] = reg[3];
  reg[3] = tmp;
  if (se >= REGS) {
    printf("POP.W  R%d\n", reg[3]);
  }
}

push(char *ident) {
  pushrename();
  printf("MOVE.W  %s,R%d\n", ident, reg[0]);
  prregs();
}

pop(char *ident) {
  printf("MOVE.W  R%d,%s\n", reg[0], ident);
  poprename();
  prregs();
}

sub() {
  printf("SUB.W  R%d,R%d\n", reg[0], reg[1]);
  poprename();
  prregs();
}


main() {
  prregs();
  push("a");
  push("b");
  sub();
  pop("c");
  push("aa");
  push("bb");
  push("cc");
  push("dd");
  push("ee");
  push("ff");
  sub();
  pop("x");
  sub();
  pop("y");
  sub();
  pop("z");
}  
    
