%{
  /* tbng01.l
   * Tiny BASIC no GOTO lexer
   *
   * by Andre Adrian
   *
   * version 28may2006
   */ 
  #include "y.tab.h"
  #include <stdlib.h>
  void yyerror(char *);
%}

%%

"array"     { return ARRAY; }
"begin"     { return BEGINN; }
"break"     { return BREAK; }
"char"      { return CHAR; }
"do"	    { return DO; }
"else"	    { return ELSE; }
"end"       { return END; }
"endif"	    { return ENDIF; }
"forward"   { return FORWARD; }
"func"      { return FUNC; }
"if"  	    { return IF; }
"int"       { return INT; }
"return"    { return RETURN; }
"then"	    { return THEN; }
"var"       { return VAR; }
"void"      { return VOID; }
"wend"	    { return WEND; }
"while"	    { return WHILE; }
"<="	    { return LE; }
">="	    { return GE; }


'.+'        { yylval = yytext[1];
              return CHRCONST;
            }
            
\".+\"      { yylval = yytext[1];
              return STRCONST;
            }
            
[a-z]       { yylval = yytext[0];
              return IDENT;
            }

[0-9]+      { yylval = atoi(yytext);
              return CONST;
            }

[-+*/,:;()=#<>&|!]  { return *yytext; }

"["         { return *yytext; }
"]"         { return *yytext; }
"\n"        { return ';'; }

[ \t]       ;       /* skip whitespace */

.           yyerror("Unknown character");

%%

int yywrap(void) {
    return 1;
}
